/*
* Generate a URL-escaped name, without space, /, $ and %.
* Escaped characters are represented by %XX, where XX is the
* hexadecimal representation.
*/
#include <tcl.h>
#include <ctype.h>
#include <string.h>
#include "ansi.h"


int nospace_cmd(ClientData client, Tcl_Interp *interp, int argc, 
  char *argv[])
{
  char *s, *d;

  if (argc != 2) {
    sprintf(interp->result, "%s: illegal # of args (%d)", argv[0], argc);
    return TCL_ERROR;
  }

  d = interp->result;
  for (s = argv[1]; *s; s++) {
    if (strchr("/$% ", *s)) {
      sprintf(d, "%%%02x", (unsigned)(*s));
      d += strlen(d);
    }
    else *d++ = *s;
  }
  *d = '\0';
  
  return TCL_OK;
} /* nospace_cmd */
