#
# $Id: control_isc.tcl,v 1.2 1998/07/20 16:41:29 stb Exp $
#
# Initialize and send messages to conferencing system.
# If first choice fails, fall back to tcp.
#
proc control_init {controller} {
  global prog_name debug


  if {[lsearch $debug pmm] >= 0} {puts "$prog_name: $controller"}
    control_init_udp $controller
 # if [catch {control_init_[lindex $controller 0] $controller} msg] {
 #   puts stderr "Error in control_init: $msg"
 #   control_init_tcp "tcp localhost [lindex $controller 2]" 
 # }
}


#
# Process command and ignore unknown commands.
# "Fake hello": if there's a member command for an unknown member,
# but with known session, we treat it like a hello.
#
proc control_cmd {op cmd} {
  if {[info proc $op] == ""} {
    set c [split $op /]
    set cs [join [lrange $c 0 2] /]
    # session known, so pretend there was a "hello"
    if {[info proc $cs] != ""} {
      session [lindex $c 1]/[lindex $c 2] hello [lindex $c 3]
      # if still unknown, we got a problem
      if {[info proc $op] == ""} {
        footer "Couldn't create $cs"
      }
    } else {
      return
    }
  }
  eval $cmd
}


#
# Generic evaluation of command.
# control_tcp generates zero-length messages if the message
# is incomplete, thus we can't use it to exit on EOF.
# Catch no_interest to avoid endless loops.
# Don't send back error reports to avoid loops.
#
proc control_eval {cmd} {
  global prog_name debug

  if {[string length $cmd] > 0} {
    set op [lindex $cmd 0]
    switch -exact -- $op {
      session -
      + -
      - {
      }
      set -
      proc -
      exec -
      rename {
        puts stderr "[pid] $prog_name: forbidden command: $cmd"
      }
      default {
        control_cmd $op $cmd
      } 
    }
  }
}
