#
# $Id: field.tcl,v 1.2 1998/07/20 16:41:32 stb Exp $
#
proc tab_init { list } {
  set x {}
  foreach w $list {
    if {[winfo exists $w.in]} {
      lappend x $w.in
    }
  }
  foreach w $x {
    bind $w <Tab> "tab [list $x]" 
    bind $w <Return> "tab [list $x]" 
  }
}

proc tab list {
  set i [lsearch $list [focus]]
  incr i
  if {$i >= [llength $list]} {
    set i 0
  }
  focus [lindex $list $i]
}


#
# field_num: numerical field
# w:           window
# label_text:  text of label
# label_width: width of label
# entry_width: width of entry
# unit:        label for units
# v:           name of global (!) variable
#
proc field_num { w label_text label_width entry_width unit v } {
  global $v

  if {$label_width < 0} {
    set label_width [string length $label_text]
  }

  frame $w
  frame $w.buttons
  button $w.buttons.up   -bitmap arrow_up   -command "button_inc $v 1"
  button $w.buttons.down -bitmap arrow_down -command "button_inc $v -1"
  pack $w.buttons.up $w.buttons.down -side top
  label $w.label -text "$label_text:" -width $label_width -anchor nw
  entry $w.in -width $entry_width -relief sunken -textvariable $v
  pack $w.label $w.in $w.buttons -side left
  if {$unit != ""} {
    pack [label $w.unit -text $unit -anchor nw] -side right
  }
  bind $w.in <Left> {%W icursor [expr [%W index insert] - 1]} 
  bind $w.in <Right> {%W icursor [expr [%W index insert] + 1]} 
  bind $w.in <Control-a> {%W icursor 0; %W view 0} 
  bind $w.in <Control-e> {
    %W icursor end; %W view [expr [%W index end] - 10]
  }
  return $w
}

proc field_str { w label_text label_width entry_width unit v } {
  global $v

  if {$label_width < 0} {
    set label_width [string length $label_text]
  }
  frame $w
  label $w.label -text "$label_text" -width $label_width -anchor nw
  entry $w.in -width $entry_width -relief sunken -textvariable $v
  pack $w.label $w.in -side left 
  if {$unit != ""} {
    pack [label $w.unit -text $unit -anchor nw] -side right
  }
  bind $w.in <Left> {%W icursor [expr [%W index insert] - 1]} 
  bind $w.in <Right> {%W icursor [expr [%W index insert] + 1]} 
  bind $w.in <Control-a> {%W icursor 0; %W view 0} 
  bind $w.in <Control-e> {
    %W icursor end; %W view [expr [%W index end] - 10]
  }
  return $w
}
