#
# User interface for playing audio files.
#
# $Id: play.tcl,v 1.2 1998/07/20 16:41:38 stb Exp $
#
proc play_set {s v} {
  global $v conf

  if {$s == "*"} {set s ""}
  control_send "$conf(id)/$s play [set $v]"
}

proc play_play {s {f foo}} {
  global conf play_monitor play_loop

  if {$s == "*"} {set s ""}
  .play.cmd.pause configure -state normal -text "Pause"

  control_send "$conf(id)/$s play $play_loop $play_monitor $f"
}

proc play_cancel {s} {
  global conf

  if {$s == "*"} {set s ""}
  control_send "$conf(id)/$s play -stop"
  destroy .play
}


#
# switch button labels
#
proc play_pause {s w} {
  global conf

  if {$s == "*"} {set s ""}
  if {[lindex [$w.cmd.pause configure -text] 4] == "Pause"} {
    control_send "$conf(id)/$s play -pause"
    $w.cmd.pause configure -text "Resume"
  } else {
    control_send "$conf(id)/$s play -resume"
    $w.cmd.pause configure -text "Pause"
  }
}


#
# create play panel
#
proc play_panel {{s "*"} {w .play}} {
  global sound

  # create only if it doesn't exist already
  if {[winfo exists $w]} return
  toplevel $w

  # playback options
  frame $w.mode
  pack [checkbutton $w.mode.monitor -text "monitor" -relief flat \
    -variable play_monitor -offvalue "-nomonitor" -onvalue "-monitor" \
    -command "play_set $s play_monitor"] \
    -side left -anchor w
  pack [checkbutton $w.mode.loop -text "loop" -relief flat \
    -variable play_loop -offvalue "-noloop" -onvalue "-loop" \
    -command "play_set $s play_loop"] \
    -side right -anchor w

# playback commands
  frame $w.cmd
  pack [button $w.cmd.pause -state disabled -text "Pause" \
    -command "play_pause $s $w" -width 8] \
    -side left -ipadx 10

# panel
  pack [fileselect $w.fs "play_play {$s}" "play_cancel {$s}" \
    "Audio file" $sound(dir) *.$sound(suffix) Play] \
    -side top
  pack $w.mode -side top
  pack $w.cmd -side top
}
