# mkr
#
# Load parameters from preference file.
#

set CONFIG_FILE mintrc
set LIST {LAN_Default WAN_Default LAN_User WAN_User}
set Pref() {}
set preflist {}

proc load_config {} {
    global CONFIG_FILE LAN_Default WAN_Default LAN_User WAN_User preflist Pref
    
    if ![file exists ~/.$CONFIG_FILE] {
	if [catch {open ./.$CONFIG_FILE r} fileId1] {
	    #isc_message "Cannot copy $CONFIG_FILE to your home."
	    return
	} else {
	    #isc_message "Copying .mintrc to your home directory."
	    file copy -force ./.mintrc ~/.$CONFIG_FILE
	    close $fileId1
	}
    }
    
    if [catch {open ~/.$CONFIG_FILE r} fileId] {
	#isc_message "Cannot open ~/.$CONFIG_FILE: $fileId"
	return
    } else {
	set preflist {}
	while {[gets $fileId line] >= 0} {
	    if {[string length $line] > 0} {
		if {[string index $line 0] != "\#"} {
		    set parameter [lindex $line 0]
		    set value [lindex $line 1]
		    set Pref($parameter) $value
# 		    puts "Debugging ... $Pref($parameter)\n"
		    lappend preflist $parameter
# 		    puts "Debugging ... $preflist\n"
		}
	    }
	}
    }
    catch {close $fileId}
}

# changed by mkr
#
# Save parameters to configuration file
#

proc save_config {{s ""}} {
    global LIST CONFIG_FILE LAN_Default WAN_Default LAN_User WAN_User Session \
	session conf connect_env preflist Pref video

    if {$s == ""} {
	set Label [lindex $conf(sessions) 0]
	set s $Session(type)/$Session(host):$Session(port)
    }

    set value {}
    if [file exists ~/.$CONFIG_FILE] {
	catch {exec cp [glob ~/.$CONFIG_FILE] [glob ~/.$CONFIG_FILE].bak}
    }

    if [catch {open ~/.$CONFIG_FILE w} fileId] {
	#isc_message "Cannot open ~/.$CONFIG_FILE: $fileId"
    } else {
	if [catch {
	    puts $fileId "\# PREFERENCE FILE. DO NOT EDIT!"
	    puts $fileId "\# Parameter {{LAN_Default} {WAN_Default} {LAN_User} {WAN_User}}"

	
	    
	    foreach parameter $preflist {
		set Pref_${parameter} 1
	    }
	    
	    foreach parameter [array names Pref_Session] {
		if {$connect_env(net) == "LAN"} {
		    set name Session($parameter)
		    set new_param [lreplace $Pref($name) 2 2 $session($s,$parameter)]
		    set Pref(Session($parameter)) $new_param
		}
		if {$connect_env(net) == "WAN"} {
		    set name Session($parameter)
		    set new_param [lreplace $Pref($name) 3 3 $session($s,$parameter)]
		    set Pref(Session($parameter)) $new_param
		}
	    }
	    
	    foreach parameter [array names Pref_video] {
		if {$connect_env(net) == "LAN"} {
		    set name video($parameter)
		    set new_param [lreplace $Pref($name) 2 2 $video($parameter)]
		    set Pref(video($parameter)) $new_param
		}
		if {$connect_env(net) == "WAN"} {
		    set name video($parameter)
		    set new_param [lreplace $Pref($name) 3 3 $video($parameter)]
		    set Pref(video($parameter)) $new_param
	     	    }
	    } 
	    
	    foreach parameter $preflist {
		set value1 [lindex $Pref($parameter) 0]
		set value2 [lindex $Pref($parameter) 1]
		set value3 [lindex $Pref($parameter) 2]
		set value4 [lindex $Pref($parameter) 3]
		# 	    puts "$parameter {{$value1} {$value2} {$value3} {$value4}}"
		puts $fileId "$parameter {{$value1} {$value2} {$value3} {$value4}}"
	    }
	}] {
	    isc_message "Error while writing .mintrc. Moved .mintrc.bak back to .mintrc."
	    exec cp [glob ~/.$CONFIG_FILE.bak] [glob ~/.$CONFIG_FILE]
	}
    }   
    catch {close $fileId}
}


# # changed by mkr
# #
# # print preferences to stdout. only used for debugging ...

# proc print_config {} {
#     global LIST LAN_Default WAN_Default LAN_User WAN_User
    
#     foreach j $LIST {
# 	foreach i [array names $j] {
# 	    puts "${j}($i) = [set ${j}($i)]"
# 	}
#     }
# }

# changed by mkr
#
# set session parameters to loaded preference values

proc set_config {{s ""}} {
    global LIST LAN_Default WAN_Default LAN_User WAN_User session Session \
	connect_env conf preflist Pref video
    
    if {$s == ""} {
	set Label [lindex $conf(sessions) 0]
	set s $Session(type)/$Session(host):$Session(port)
    }

    set name $connect_env(net)
    append name "_" $connect_env(type)

    foreach parameter $preflist {
	set value0 [lindex $Pref($parameter) 0]
	set value1 [lindex $Pref($parameter) 1]
	set value2 [lindex $Pref($parameter) 2]
	set value3 [lindex $Pref($parameter) 3]
	if {$connect_env(net) == "LAN"} {
	    if {$connect_env(type) == "Default"} {
		catch [set $parameter $value0]
# 		puts "\#mkr/session.tcl: $connect_env(type) $connect_env(net)"
# 		puts "\#mkr/session.tcl: Setting $parameter $value0"
	    } else {
		catch [set $parameter $value2]
# 		puts "\#mkr/session.tcl: $connect_env(type) $connect_env(net)"
# 		puts "\#mkr/session.tcl: Setting $parameter $value2"
	    }
	} else {
	    if {$connect_env(type) == "Default"} {
		catch [set $parameter $value1]
# 		puts "\#mkr/session.tcl: $connect_env(type) $connect_env(net)"
# 		puts "\#mkr/session.tcl: Setting $parameter $value1"
	    } else {
		catch [set $parameter $value3]
# 		puts "\#mkr/session.tcl: $connect_env(type) $connect_env(net)"
# 		puts "\#mkr/session.tcl: Setting $parameter $value3"
	    }
	}
	foreach e [array names Session] {
	    set session($s,$e) $Session($e) 
	}
    }
# 	if {![info exists session($s,$i)]} {
# 	    puts "Parameter $i does not exist!"
# 	} else {
# 	    #set session($s,$i) [set ${name}($i)]
# 	    puts "\#mkr/session.tcl: Setting parameter [set ${name}($i)
#  	    set Session($i) [set ${name}($i)]
# 	}
}
