#
# $Id: record.tcl,v 1.5 1998/07/31 13:19:49 stb Exp $
#
proc record_record {s f} {
  global conf record_append _record_info

  if {$s == "*"} {set s ""}
  .record.cmd.pause configure -state normal -text "Pause"
  control_send "$conf(id)/$s record $record_append -info {$_record_info} $f"
}

proc record_cancel {s} {
  global conf

  if {$s == "*"} {set s ""}
  control_send "$conf(id)/$s record -stop"
  destroy .record
}

#
# Pause and resume audio.
#
proc record_pause {s w} {
  global conf

  if {$s == "*"} {set s ""}
  if {[lindex [$w.cmd.pause configure -text] 4] == "Pause"} {
    control_send "$conf(id)/$s record -pause"
    $w.cmd.pause configure -text "Resume"
  } else {
    control_send "$conf(id)/$s record -resume"
    $w.cmd.pause configure -text "Pause"
  }
}

proc record_panel {{s "*"} {w .record}} {
  toplevel $w

  # record options
  frame $w.mode
  pack [checkbutton $w.mode.append -text "append" -relief flat \
    -variable record_append -offvalue "" -onvalue "-append"] \
    -side left -anchor w

  # record commands
  frame $w.cmd
  pack [button $w.cmd.pause -state disabled -text "Pause" \
    -command "record_pause $s $w" -width 8] \
    -side left -padx 10

  # panel
  pack [fileselect $w.fs "record_record $s" "record_cancel $s" \
    "Audio file" . *.au Record] \
   -side top
  pack [field_str $w.info "Description" -1 25 "" _record_info] \
   -side top -anchor nw
  pack $w.mode -side top
  pack $w.cmd  -side top
}
