/* @(#)util.c	1.5 97/12/23 */

/*
 * Copyright (c) Communications Research Centre, Government of Canada 1997. 
 * All rights reserved.
 * 
 * License is granted to copy and use this software, for research and
 * evaluation purposes, provided that the Communications Research Centre
 * is acknowledged in all documentation pertaining to any such copy or
 * use. The Communications Research Centre grants no other licenses
 * expressed or implied. Title, ownership rights, and intellectual
 * property rights in the software shall remain with the Communications
 * Research Centre.  The Centre's name and the Government of Canada
 * should not be used in any advertising without written permission.
 * 
 * THE COMMUNICATIONS RESEARCH CENTRE MAKES NO REPRESENTATIONS CONCERNING
 * EITHER THE MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF
 * THIS SOFTWARE FOR ANY PARTICULAR PURPOSE.  The software is provided
 * "as is" without express or implied warranty of any kind.
 * 
 * These notices must be retained in any copies of any part of this
 * software.
 */


#include "mpoll.h"

/* ----------------------------------------------------------------- */
/* print a warning message */
warning(char *message)
   {
   fprintf(stderr, "MPoll WARNING: %s\n", message);
   return(0);
   }
   
/* ----------------------------------------------------------------- */
/* print a message and die */
die(char *message)
   {
   fprintf(stderr, "MPoll FATAL ERROR: %s\n", message);
   exit(1);
   }
   
/* ----------------------------------------------------------------- */
/* translate an IP number into a hostname */
char *iptohost(char *ip)
   {
   u_long addr;
   struct hostent *hp;
   char *hostname = NULL;   
   
   addr = inet_addr(ip);
   hp = gethostbyaddr((char *)&addr, sizeof(addr), AF_INET);
   if (hp == NULL)
      {
      hostname = strdup(ip);
      return hostname; 
      }
   hostname = strdup(hp->h_name);
   return hostname;
   }
