/*
* Return offset from GMT, measured in seconds.  If locale is ahead of
* GMT, offset is positive.
*/
#include <time.h>

static char rcsid[]  = "$Id: gmtoff.c,v 1.1.1.1 1997/11/12 17:16:09 dor Exp $";

int gmtoff(void)
{
  struct {
    struct tm tm;
    int sec;
  } local, gmt;
  int diff;
  time_t c;
  
  time(&c);
  gmt.tm = *(gmtime(&c));
  local.tm = *(localtime(&c));

  gmt.sec = gmt.tm.tm_hour * 3600 + gmt.tm.tm_min * 60 + gmt.tm.tm_sec;
  local.sec = local.tm.tm_hour * 3600 + local.tm.tm_min * 60 + local.tm.tm_sec;

  diff = local.sec - gmt.sec;
  if (diff > 86400) diff -= 86400;
  else if (diff < -86400) diff += 86400;
  return diff; 
}
