/*
* tx.h -- Definitions for NeVoT transmitter.
* $Id: tx.h,v 1.1.1.1 1997/11/12 17:16:34 dor Exp $
*/

#include "agc.h"
#include "sd.h"
#include "peakmeter.h"

/* transmission configuration parameters (tx.c) */
struct TX_t {
  /* for audio file */
  struct {
    int bytes;          /* bytes from file for one chunk */
    audio_file_t af;    /* descriptor */
    int monitor;        /* monitor output */
    FILE *f;            /* file descriptor */
    int on;             /* playing enabled */
    int loop;           /* play loop */
  } f;
  /* physical audio input */
  struct {
    int monitor;        /* monitor microphone, etc. */
  } in;
  int monitor;          /* monitor audio output (file or microphone) */
  int enable;           /* enable talking */
  int echo_supp;        /* enable echo suppression */
  int spurt[2];         /* packets before/after talkspurt */
  float release;        /* idle seconds after which to release audio */
  agc_t *agc;           /* automatic gain control state */
  sd_t *sd;             /* silence detector */
  peakmeter_t *pm;      /* peak meter */
  /* transient */
  int bot;              /* beginning of talkspurt */
  u_int32 samples;      /* audio samples (NOT reset after reopening device) */
  u_int32 silent;       /* silent packets */
  /* statistics */
  u_int32 record_errors;
};
