#
# Remote control functions using UDP
#
# $Id: control_udp.tcl,v 1.1.1.1 1997/11/12 17:16:27 dor Exp $
#

#
# Source and destination port on all multicast packets is 5010
# (sending port uses bind(), so that we have no way of knowing whether
# we see our own transmissions or those from another process.  
#

proc control_read_udp {sock} {
  control_eval [gets $sock]
}

proc control_init_udp {controller} {
  global cdest cfile c

  set host [lindex $controller 1]
  set port [lindex $controller 2]
  set c [udp $host $port]
  Tcl_SetSockBuffer $c
  fconfigure $c -ttl 0  
  fconfigure $c -buffering none
  fconfigure $c -member 1
  fileevent $c readable {control_read_udp $c}

  # define sending procedure
  proc control_send {msg} {
    global cdest cfile prog_name debug c

  if {[lsearch $debug pmm] >= 0} {puts "$prog_name -> $msg"}
  puts -nonewline $c $msg 
  }
}
