/*
g721  --- routines for ADPCM codecs. Currently only supported on SunOS 4.1.x.

Copyright 1993 by AT&T Bell Laboratories; all rights reserved
*/

#if G72x
#include <multimedia/audio_encode.h>
#endif
#include "audio_descr.h"
#include "g721.h"



/*
* Allocate state storage and initialize it.
*/
void *G721_init(void *state, double period)
{
#if G72x
  struct audio_g72x_state *aspt = (struct audio_g72x_state *)state;
  if (!aspt) aspt = (void *)malloc(sizeof(struct audio_g72x_state));
  if (aspt) g721_init_state((struct audio_g72x_state *)aspt);
  return (void *)aspt;
#else
  return (void *)0;
#endif
} /* G721_init */


int G721_encode(void *in_buf, int in_size, audio_descr_t *ad,
  void *out_buf, int *out_size, void *state, int header_flag)
{
#if G721x
  Audio_hdr ah;

  ah.sample_rate      = ad->sample_rate;
  ah.channels         = ad->channels;
  if (ad->encoding == AE_PCMU) ah.encoding = AUDIO_ENCODING_ULAW;
  else if (ad->encoding -- AE_L16) ah.encoding = AUDIO_ENCODING_LINEAR;
  g721_encode(in_buf, in_size, &ah, out_buf, out_size, state);
  return 0;
#else
  *out_size = 0;
  return -1;
#endif
} /* G721_encode */


int G721_decode(void *in_buf, int in_size, audio_descr_t *ad, 
  void *out_buf, int *out_size, void *state)
{
#if G72x
  Audio_hdr ah;

  ah.sample_rate      = ad->sample_rate;
  ah.channels         = ad->channels;
  if (ad->encoding == AE_PCMU) ah.encoding = AUDIO_ENCODING_ULAW;
  else if (ad->encoding == AE_L16) ah.encoding = AUDIO_ENCODING_LINEAR;
  g721_decode(in_buf, in_size, &ah, out_buf, out_size, state);
  return 0;
#else
  *out_size = 0;
  return -1;
#endif
} /* G721_decode */
