/*
terminate  --  clean-up routine

Copyright 1994 by Henning Schulzrinne; all rights reserved
*/

#include "nevot.h"
#include "debug.h"
#include "audio_generic.h" /* A_WR */
#include <stdlib.h>        /* exit() */
#include <ansi.h>



/*
* Called on normal exit.
*/
void Audio_exit(void)
{
  Audio_session_t s, s_next;

  for (s = nevot.first; s; s = s_next) {
    s_next = s->next;
    Audio_SessionDelete(s);
  }

  audio_close();
  tx_packet_close();
  debug_close();
  /*
   * Delete pid locking file. We don't care if it doesn't exist
   * or if we can't access it (probably wouldn't have been able
   * to start in that case anyway.)
   */
  unlink("/usr/tmp/nevot.pid");
} /* Audio_exit */
