#
# Tcl client to check if invited user has enabled his automatic reply function
# returns reply_code and reason_phrase 
#

if [string match "sip://*" $from] {
    set from [string range $from 6 end]
}

if {![file readable ${HOME}/.sipforward]} {
    exit 1
}

# read handler_file
set file_handler [open ${HOME}/.sipforward r]
 seek $file_handler 0
 set lines [split [read $file_handler] "\n"]
 close $file_handler

 foreach line $lines {
     set l [split $line "\t"]
     if {[lindex $l 0] == "*"} {
	 puts "[lindex $l 2] [lindex $l 3]"
	 return TCL_OK
	 
     }

    if {[lindex $l 0] == "from"} {
	if [string match [lindex $l 1] $from] {
	    puts "[lindex $l 2] [lindex $l 3]"
	    return TCL_OK
	}
    }

    if {[lindex $l 0] == "subject"} {
	if [string match [lindex $l 1] $subject] {
	    puts "[lindex $l 2] [lindex $l 3]"
	    return TCL_OK
	}
    }

}

exit 1



