#include <sys/types.h>
#include <stdio.h>
#include <sys/socket.h>      /* struct sockaddr */
#include <netdb.h>           /* gethostbyname() */
#include <netinet/in.h>      /* sockaddr_in */
#include <arpa/inet.h>       /* inet_addr() */             
#include <tcl.h>

char* host2dottednotation(char *host)
{
  struct in_addr in;
  register struct hostent *hep;

  /* Check whether this is a dotted decimal. */
  if (!host) {
    in.s_addr = INADDR_ANY;
  }
  else if ((in.s_addr = inet_addr(host)) != -1) {
  }
  /* Attempt to resolve host name via DNS. */
  else if ((hep = gethostbyname(host))) {
    in = *(struct in_addr *)(hep->h_addr_list[0]);
  }
  return inet_ntoa(in);
} /* host2ip */
        


int Tcl_host2dottednotation(ClientData client, Tcl_Interp *interp, int argc, char *argv[])
{
  if (argc != 2) {
    sprintf(interp->result, "%s: illegal # of args (%d)", argv[0], argc);
    return TCL_ERROR;
  }

  sprintf(interp->result, "%s", host2dottednotation(argv[1]));

  return TCL_OK;
} /* Tcl_idstring */
                                
