AC_ARG_WITH(tcl,	--with-tcl=path	specify a pathname for tcl, d=$withval, d="")

if test "$d" != "" ; then 
	if test ! -d $d ; then 
		echo "'$d' is not a directory"
		exit 1
	fi
	V_INCLUDE_TCL=-I$d/include
	if test ! -r $d/include/tcl.h ; then
		echo "can't find tcl.h in $d/include"
		exit 1
	fi




	echo $ac_n "checking for libtcl7.5.so... $ac_c"
	places="$d/lib/"
	V_LIB_TCL=FAIL
	for dir in $places; do
	    if test -r $dir/libtcl7.5.so; then
		V_LIB_TCL="-L$dir -ltcl7.5"
		break
	    fi
	    if test -r $dir/libtcl75.so.*; then
		V_LIB_TCL="-L$dir -ltcl75"
		break
	    fi
	    if test -r $dir/libtcl.so; then
		V_LIB_TCL="-L$dir -ltcl"
		break
	    fi
	done
	if test "$V_LIB_TCL" = FAIL; then
		echo "can't find libtcl7.5.so"
	else
		echo yes
                V_LIB_TCL="-Wl,-R$dir $V_LIB_TCL"
	fi




	places="$d/lib\
		$d/lib/static"

	V_LIB_TCL_STATIC=FAIL
	echo $ac_n "checking for libtcl7.5.a... $ac_c"
	for dir in $places; do
	    if test -r $dir/libtcl7.5.a; then
		V_LIB_TCL_STATIC="-L$dir -Wl,-Bstatic -ltcl7.5 -Wl,-Bdynamic"
		break
	    fi
	    if test -r $dir/libtcl75.a; then
		V_LIB_TCL_STATIC="-L$dir -Wl,-Bstatic -ltcl75 -Wl,-Bdynamic"
		break
	    fi
	done

	if test "$V_LIB_TCL_STATIC" = FAIL; then
		echo "can't find libtcl7.5.a"
		STANDALONE="NO"
		V_LIB_TCL_STATIC=""
	else 
		echo yes
		if test "$STANDALONE" = YES; then
			STANDALONE=`nm $dir/libtcl7.5.a | grep Tcl_InitStandAlone`
			if test -z "$STANDALONE"; then
				STANDALONE=NO
			else
				STANDALONE=YES
			fi
		fi	
	fi


	places="$d/lib/tcl7.5 \
		$d/lib/tcl"
	V_LIBRARY_TCL=FAIL

	for dir in $places; do
		if test -r $dir/init.tcl ; then
			V_LIBRARY_TCL=$dir
			break
		fi
	done
	if test $V_LIBRARY_TCL = FAIL ; then
		echo "can't find init.tcl in $d/lib/tcl"
		exit 1
	fi
else
	AC_TEST_CPP([#include <tcl.h>], V_INCLUDE_TCL="", V_INCLUDE_TCL=FAIL)
	if test "$V_INCLUDE_TCL" = FAIL; then
		echo "checking for tcl.h"
		places="$PWD/../tcl7.5 \
			/usr/src/local/tcl7.5 \
			/import/tcl/include/tcl7.5 \
			$prefix/include \
			$x_includes/tk \
			$x_includes \
			/usr/local/include \
			/usr/contrib/include \
			/usr/include"
		for dir in $places; do
			if test -r $dir/tcl.h ; then
				V_INCLUDE_TCL=-I$dir
			        break
			fi
		done
		if test "$V_INCLUDE_TCL" = FAIL; then
			echo "can't find tcl.h"
			exit 1
		fi
	fi

	AC_CHECK_LIB(tcl7.5, main, V_LIB_TCL="-ltcl7.5", V_LIB_TCL="FAIL")
	if test "$V_LIB_TCL" = FAIL; then
	    AC_CHECK_LIB(tcl75, main, V_LIB_TCL="-ltcl75", V_LIB_TCL="FAIL")
	fi
	if test "$V_LIB_TCL" = FAIL; then
		echo $ac_n "checking for libtcl.so ...$ac_c"
		places="\
			$prefix/lib \
			$x_libraries \
			/usr/contrib/lib \
			/usr/local/lib \
			/usr/lib \
			$PWD/../tcl7.5 \
			/usr/src/local/tcl7.5 \
			/import/tcl/lib/tcl7.5 \
			"
		for dir in $places; do
			if test -r $dir/libtcl7.5.so; then
				V_LIB_TCL="-L$dir -ltcl7.5"
				break
			fi
			if test -r $dir/libtcl75.so.*; then
				V_LIB_TCL="-L$dir -ltcl75"
				break
			fi
			if test -r $dir/libtcl.so; then
				V_LIB_TCL="-L$dir -ltcl"
				break
			fi
		done
		if test "$V_LIB_TCL" = FAIL; then
			echo "can't find libtcl.so"
			exit 1
		else
			echo yes
			if test $solaris ; then
				V_LIB_TCL="-R$dir $V_LIB_TCL"
			fi
		fi
	fi

        V_LIB_TCL_STATIC=FAIL
	echo $ac_n "checking for libtcl.a ...$ac_c"
	places="\
		$prefix/lib \
		$x_libraries \
		/usr/contrib/lib \
		/usr/local/lib \
		/usr/lib \
		$PWD/../tcl7.5 \
		/usr/src/local/tcl7.5 \
		/import/tcl/lib/tcl7.5 \
		"
		for dir in $places; do
		if test -r $dir/libtcl7.5.a; then
			 V_LIB_TCL_STATIC="$dir/libtcl7.5.a"
			 break
		fi
		if test -r $dir/libtcl75.a; then
			 V_LIB_TCL_STATIC="$dir/libtcl75.a"
			 break
		fi
		if test -r $dir/libtcl.a ; then
			 V_LIB_TCL_STATIC="$dir/libtcl.a"
			 break
		fi
	done

	if test "$V_LIB_TCL_STATIC" = FAIL; then
		echo "can't find libtcl.a"
		STANDALONE="NO"
		V_LIB_TCL_STATIC=""
	else
		echo yes
		if test "$STANDALONE"=YES; then
			STANDALONE=`nm $V_LIB_TCL_STATIC|grep  Tcl_InitStandAlone`
			if test -z "$STANDALONE"; then
				STANDALONE=NO
	        	else
				STANDALONE=YES
			fi
		fi

	fi

	echo "checking for tcl/init.tcl"
	V_LIBRARY_TCL=FAIL
	places="/usr/local/lib/tcl7.5 \
		/usr/contrib/lib/tcl7.5 \
		/usr/lib/tcl7.5 \
		/usr/lib/tk/tcl7.5 \
		/import/tcl/lib/tcl7.5 \
		$prefix/lib/tcl7.5 \
		$x_libraries/tcl7.5 \
		/usr/local/lib/tcl \
		/usr/lib/tcl \
		/usr/lib/tk/tcl \
		/import/tcl/lib/tcl \
		$prefix/lib/tcl \
		$x_libraries/tcl \
		/usr/libdata/tcl \
		$x_libraries/tcl"
	for dir in $places; do
		if test -r $dir/init.tcl; then
			V_LIBRARY_TCL=$dir
			break
		fi
	done
	if test "$V_LIBRARY_TCL" = FAIL; then
		echo "can't find tcl/init.tcl"
		exit 1
	fi
fi
AC_SUBST(V_INCLUDE_TCL)
AC_SUBST(V_LIB_TCL)
AC_SUBST(V_LIBRARY_TCL)
AC_SUBST(V_LIB_TCL_STATIC)











