
#include        "tclInt.h"      /* Internal definitions for Tcl. */
#include        "tclPort.h"     /* Portability features for Tcl. */
#include        "tclUdp.h"
/*
 *----------------------------------------------------------------------
 *
 * Udp_Init --
 *
 *	This procedure performs library-specific initialization.
 *	Most applications, especially those that incorporate additional
 *	packages, will have their own version of this procedure.
 *
 * Results:
 *	Returns a standard Tcl completion code, and leaves an error
 *	message in interp->result if an error occurs.
 *
 * Side effects:
 *	Depends on the startup script.
 *
 *----------------------------------------------------------------------
 */

int
Udp_Init(interp)
    Tcl_Interp *interp;		/* Interpreter for application. */
{
    
    Tcl_CreateCommand(interp, "udp",
		      Tcl_UdpCmd,
		      (ClientData) NULL,
		      (Tcl_CmdDeleteProc *) NULL);

    return TCL_OK;
}

